
#include <iostream.h>
#include <math.h>
#include <string.h>

struct coord3D { 
  double x;
  double y;
  double z;
};


class subdivSurface {

  protected :
     
  struct coord3D * controlPoints;
  struct coord3D * interpolatedPoints;
  struct coord3D * tmpPoints;

  int patchW,patchL;
  int pointW,pointL;
  int nbSubdivisions;

  int  nbControlPoints;
  bool patchOk;
  bool smooth;
  bool showControlPoints;

  int selectedPoint;

  void getFaceNormal(int x,int y,struct coord3D * normal);
  void getVertexNormal(int x,int y,struct coord3D * normal);
  void getPoint(int x,int y,struct coord3D * point);

  public :

  subdivSurface(int patchLength, int patchWidth);
  ~subdivSurface();
  
  bool addControlPoint(double x, double y,double z);
  void setSmooth(bool s);
  void setShowControlPoints(bool s);

  bool subdivideOneTime();
  bool undoLastSubdivision();
  bool reSubdivide(int n);

  void nextColumn();
  void previousColumn();
  void nextRow();
  void previousRow();

  void moveSelectedPointX(int x);
  void moveSelectedPointY(int y);
  void moveSelectedPointZ(int z);

  void drawSurface();

};
